package org.processmining.activityclusterarraycreator.connections;

import org.processmining.activityclusterarray.models.ActivityClusterArray;
import org.processmining.activityclusterarraycreator.parameters.ConvertCausalActivityGraphToActivityClusterArrayParameters;
import org.processmining.causalactivitygraph.models.CausalActivityGraph;
import org.processmining.framework.connections.impl.AbstractConnection;

public class ConvertCausalActivityGraphToActivityClusterArrayConnection extends AbstractConnection {

	public final static String GRAPH = "Graph";
	public final static String CLUSTERS = "Clusters";

	private ConvertCausalActivityGraphToActivityClusterArrayParameters parameters;

	public ConvertCausalActivityGraphToActivityClusterArrayConnection(CausalActivityGraph graph,
			ActivityClusterArray clusters, ConvertCausalActivityGraphToActivityClusterArrayParameters parameters) {
		super("Convert Causal Activity Graph To Activity Cluster Array Connection");
		put(GRAPH, graph);
		put(CLUSTERS, clusters);
		this.parameters = new ConvertCausalActivityGraphToActivityClusterArrayParameters(parameters);
	}

	public ConvertCausalActivityGraphToActivityClusterArrayParameters getParameters() {
		return parameters;
	}
}
