package org.processmining.activityclusterarraycreator.utils;

import java.util.HashSet;
import java.util.Set;

import org.deckfour.xes.classification.XEventClass;
import org.processmining.activityclusterarray.models.ActivityClusterArray;
import org.processmining.activityclusterarray.models.impl.ActivityClusterArrayFactory;

public class ClusterUtils {

	public static ActivityClusterArray merge(ActivityClusterArray oldClusters, Set<Set<XEventClass>> clusters) {
		ActivityClusterArray newClusters = ActivityClusterArrayFactory.createActivityClusterArray();
		newClusters.init(oldClusters);
		
		for (Set<XEventClass> oldCluster : oldClusters.getClusters()) {
			if (!clusters.contains(oldCluster)) {
				newClusters.addCluster(oldCluster);
				newClusters.setInputs(oldCluster, oldClusters.getInputs(oldCluster));
				newClusters.setOutputs(oldCluster, oldClusters.getOutputs(oldCluster));
			}
		}

		Set<XEventClass> newCluster = new HashSet<XEventClass>();
		Set<XEventClass> inputs = new HashSet<XEventClass>();
		Set<XEventClass> outputs = new HashSet<XEventClass>();
		for (Set<XEventClass> cluster : clusters) {
			newCluster.addAll(cluster);
			inputs.addAll(oldClusters.getInputs(cluster));
			outputs.addAll(oldClusters.getOutputs(cluster));
		}
		Set<XEventClass> shared = new HashSet<XEventClass>(inputs);
		shared.retainAll(outputs);
		inputs.removeAll(shared);
		outputs.removeAll(shared);
		newClusters.addCluster(newCluster);
		newClusters.setInputs(newCluster, inputs);
		newClusters.setOutputs(newCluster, outputs);
		
		return newClusters;
	}
}
